# coding: utf-8

"""
    NiFi Rest Api

    The Rest Api provides programmatic access to command and control a NiFi instance in real time. Start and                                              stop processors, monitor queues, query provenance data, and more. Each endpoint below includes a description,                                             definitions of the expected input and output, potential response codes, and the authorizations required                                             to invoke each service.

    OpenAPI spec version: 1.5.0
    Contact: dev@nifi.apache.org
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import os
import sys
import unittest

import swagger_client
from swagger_client.rest import ApiException
from swagger_client.apis.access_api import AccessApi


class TestAccessApi(unittest.TestCase):
    """ AccessApi unit test stubs """

    def setUp(self):
        self.api = swagger_client.apis.access_api.AccessApi()

    def tearDown(self):
        pass

    def test_create_access_token(self):
        """
        Test case for create_access_token

        Creates a token for accessing the REST API via username/password
        """
        pass

    def test_create_access_token_from_ticket(self):
        """
        Test case for create_access_token_from_ticket

        Creates a token for accessing the REST API via Kerberos ticket exchange / SPNEGO negotiation
        """
        pass

    def test_create_download_token(self):
        """
        Test case for create_download_token

        Creates a single use access token for downloading FlowFile content.
        """
        pass

    def test_create_ui_extension_token(self):
        """
        Test case for create_ui_extension_token

        Creates a single use access token for accessing a NiFi UI extension.
        """
        pass

    def test_get_access_status(self):
        """
        Test case for get_access_status

        Gets the status the client's access
        """
        pass

    def test_get_login_config(self):
        """
        Test case for get_login_config

        Retrieves the access configuration for this NiFi
        """
        pass

    def test_knox_callback(self):
        """
        Test case for knox_callback

        Redirect/callback URI for processing the result of the Apache Knox login sequence.
        """
        pass

    def test_knox_request(self):
        """
        Test case for knox_request

        Initiates a request to authenticate through Apache Knox.
        """
        pass

    def test_oidc_callback(self):
        """
        Test case for oidc_callback

        Redirect/callback URI for processing the result of the OpenId Connect login sequence.
        """
        pass

    def test_oidc_exchange(self):
        """
        Test case for oidc_exchange

        Retrieves a JWT following a successful login sequence using the configured OpenId Connect provider.
        """
        pass

    def test_oidc_request(self):
        """
        Test case for oidc_request

        Initiates a request to authenticate through the configured OpenId Connect provider.
        """
        pass


if __name__ == '__main__':
    unittest.main()
